/*
 * READ_CFG.CMD
 *
 * v01.01   10/03/2013  Add some flags for sw:8.20
 *
 */


typedef unsigned char           BYTE;
typedef unsigned short          WORD;
typedef unsigned long           DWORD;

typedef int                     BOOL;

typedef void                    DIR;
typedef void                    FILE;

typedef enum { ERROR=-1,OK=0 }  STATUS;

#define NULL                    (void*)0
#define TRUE                    1
#define FALSE                   0

#define DRIVE_USB       "/bd0"
#define DRIVE_HDD       "/C"
#define DRIVE_CD        "/D"
#define DRIVE_TFFS      "/F"
#define DRIVE_NAV       "/H"
#define DRIVE_USER      "/I"
#define DRIVE_JBX       "/J"


STATUS  fclose                  ( FILE *f );
STATUS  feof                    ( FILE *f );
char*   fgets                   ( char *s,int max,FILE *f );
FILE*   fopen                   ( char *fn,char *mode );
STATUS  fputs                   ( char *s,FILE *f );
char*   strcat                  ( char *dest,char *s );
int     strcmp                  ( char *s1,char *s2 );
char*   strcpy                  ( char *dest,char *src );

STATUS  ClearScreen                   ( void );
STATUS  ShowNavigationBargraph        ( void );
STATUS  StepBargraph                  ( char *txt, int per );
STATUS  ShowNavigationQuestionScreen  ( char *txt, int *answ );

int    GetCurrentLanguage       ( void );  //0=FR 1=EN 2=DE 3=IT 4=ES 5=DU 6=PO 7=SC 9=TU
STATUS GetConfigSystemFlag      ( char *value,int index );
STATUS GetHardwareConfiguration ( char *mod_id,char **data );
STATUS GetSoftwareConfiguration ( char *mod_id,char **data );

char  *hwmod[]=
{
  "CFG_HW_BT",
  "CFG_HW_GSM",
  "CFG_HW_RADIO",
  "CFG_HW_FOR_SIRIUS",
  "CFG_HW_GPS",
  "CFG_HW_IPOD",
  "CFG_HW_TUNER_ANTENNA",
  "CFG_HW_PREAMPLI",
  "CFG_HW_VIDEO_AUX",
  "CFG_HW_REAR_CAMERA",
  "CFG_HW_FAMILY",
};

char  *swmod[]=
{
  "CFG_SW_BRAND",
  "CFG_SW_G2P",
  "CFG_SW_GPH_DEM",
  "CFG_SW_PASS_NEAR",
  "CFG_SW_RDS",
  "CFG_SW_TMC",
  "CFG_SW_ZONE_APPLI",
  "CFG_SW_LOOP_MENU",
  "CFG_SW_GPH_BASE",
  "CFG_SW_ROAD_BOOK",
  "CFG_SW_FAST_DR",
  "CFG_SW_AAC",
  "CFG_SW_OGG",
  "CFG_SW_DVB",
  "CFG_SW_CAN_NETWORK",
  "CFG_SW_UNUSED_1",
  "CFG_SW_AVRCP",
  "CFG_SW_TTS_MODE",
  "CFG_SW_POI_SUB_CAT",
  "CFG_SW_FLAC",
  "CFG_SW_ECALL",
  "CFG_SW_TUNNEL",
};

int main  ( int argc,char *argv[] )
{
  FILE  *f;
  int   i;
  int   answ;
  char  *value;
  char  msg[128];

  f=fopen( DRIVE_USB "/Configuration.txt","wb" );
  if( !f )
    ShowNavigationQuestionScreen( "Error in fopen",&answ );
  else
  {
    strcpy( msg,"CurrentLanguage:" );
    switch( GetCurrentLanguage() )
    {
    case -1:
      strcat( msg,"ERROR" );
      break;
    case 0:
      strcat( msg,"FR" );
      break;
    case 1:
      strcat( msg,"EN" );
      break;
    case 2:
      strcat( msg,"DE" );
      break;
    case 3:
      strcat( msg,"IT" );
      break;
    case 4:
      strcat( msg,"ES" );
      break;
    case 5:
      strcat( msg,"DU" );
      break;
    case 6:
      strcat( msg,"PO" );
      break;
    case 7:
      strcat( msg,"SC" );
      break;
    case 8:
      strcat( msg,"UNK" );
      break;
    case 9:
      strcat( msg,"TU" );
      break;
    }
    fputs( msg,f );
    fputs( "\r\n",f );
    ShowNavigationQuestionScreen( msg,&answ );

    fputs( "\r\nGetHardwareConfiguration:\r\n",f );
    for( i=0 ; i<sizeof( hwmod )/sizeof( *hwmod ) ; i++ )
    {
      strcpy( msg,hwmod[i] );
      strcat( msg,"=" );
      if( GetHardwareConfiguration ( hwmod[i],&value )!=OK )
        strcat( msg,"ERROR" );
      else
        strcat( msg,value );
      fputs( msg,f );
      fputs( "\r\n",f );
      ShowNavigationQuestionScreen( msg,&answ );
    }

    fputs( "\r\nGetSoftwareConfiguration:\r\n",f );
    for( i=0 ; i<sizeof( swmod )/sizeof( *swmod ) ; i++ )
    {
      strcpy( msg,swmod[i] );
      strcat( msg,"=" );
      if( GetSoftwareConfiguration ( swmod[i],&value )!=OK )
        strcat( msg,"ERROR" );
      else
        strcat( msg,value );
      fputs( msg,f );
      fputs( "\r\n",f );
      ShowNavigationQuestionScreen( msg,&answ );
    }
    fclose( f );
    ShowNavigationQuestionScreen( "done",&answ );
  }
  ClearScreen();
  return 0;
}