/*
 * RTxSET.CMD by mira308sw
 *
 * WARNING!:
 *  this script work only with modified version of Builtins.out crc=19bb6041
 *  in which the function ExecuteFlasherOut can pass to called funptr till to
 *  seven integers (or addresses) parameters
 *
 * Either RT4 and RT5 are supported.
 *
 * before start is possible to do a backup/restore of current user_com.dat file.
 * user is prompted sequencially to choice if change or not some settings.
 * at the end reboot the system to the change take in effect.
 *
 * v 01.00: 26/12/2008  first realease
 * v 01.01: 06/01/2009  add sw:7.02 support
 * v 02.01: 07/01/2009  add sw:8.10 support, add more items divided in sections
 * v 02.02: 10/01/2009  add some definitions
 * v 02.10: 18/01/2009  work on tmp file to avoid damage if something goes wrong
 * v 02.30: 15/03/2009  add some item definition
 * v 03.00: 26/04/2009  add list of values
 * v 03.01: 20/06/2009  add diag section for 8.11
 * v 03.20: 06/07/2010  add sw:8.20 support, add front/rear beep in audio
 * v 03.21: 22/12/2010  add some definitions
 * v 03.51: 04/09/2011  add keyboard section
 * v 03.52: 26/01/2014	add support for Maserati M2009 MS12.P.R1 
 * v 03.53: 02/03/2014	add Arkamys parameter in Audio section 
 */

/* Functions and data types from Integrated C Interpreter
 */
typedef unsigned char           BYTE;
typedef unsigned short          WORD;
typedef unsigned long           DWORD;

typedef int                     BOOL;

typedef void                    DIR;
typedef void                    FILE;

typedef enum { ERROR=-1,OK=0 }  STATUS;

#define LOAD_NO_SYMBOLS         2
#define LOAD_LOCAL_SYMBOLS      4
#define LOAD_GLOBAL_SYMBOLS     8
#define LOAD_ALL_SYMBOLS        (LOAD_LOCAL_SYMBOLS|LOAD_GLOBAL_SYMBOLS)

#define NULL                    (void*)0

#define TRUE                    1
#define FALSE                   0

int     atoi                    ( char *s );
STATUS  close                   ( int hf );
STATUS  closedir                ( DIR *d );
STATUS  EiC_ExeFile             ( int argc,char **argv );
STATUS  fclose                  ( FILE *f );
STATUS  feof                    ( FILE *f );
char*   fgets                   ( char *s,int max,FILE *f );
FILE*   fopen                   ( char *fn,char *mode );
STATUS  fputs                   ( char *s,FILE *f );
void    free                    ( void *mem );
void    loadModule              ( int hf,int mode );
STATUS  logMsg                  ( char *fmt,...);
void*   malloc                  ( int size );
STATUS  mv                      ( char *src,char *dest );
int     open                    ( char *fn,int access,int mode );
DIR*    opendir                 ( char *dn );
int     putchar                 ( int c );
char*   strcat                  ( char *dest,char *s );
int     strcmp                  ( char *s1,char *s2 );
char*   strcpy                  ( char *dest,char *src );
int     strlen                  ( char *s );
int     strncmp                 ( char *s1,char *s2,int max );
char*   strrchr                 ( char *s,int c );
char*   strstr                  ( char *s1,char *s2 );
void    taskDelay               ( int tick );
DWORD   tickGet                 ( void );
STATUS  xcopy                   ( char *src,char *dest );
STATUS  xdelete                 ( char *src );

/* functions not yet known (for me)
 *
void    copy                    ( void );
void    creat                   ( void );
void    ExeScriptFile           ( void );
void    moduleFindByNameAndPath ( void );
void    rm                      ( void );
void    sqrt                    ( void );
void    symFindByNameAndType    ( void );
void    unldByModuleId          ( void );
void    unldByNameAndPath       ( void );
 */

/* Funcions and data type from modified builtins.out crc=19bb6041
 */
void    AddGatewayHistory         ( void );
STATUS  AddUPGHistoryHeader       ( char *cd,char *target,char *action );
STATUS  BootRomFormatTffs         ( void );
void    CheckCRCDrive             ( void );
STATUS  CheckCRCFile              ( char *fn );
STATUS  ComputeCRCFile            ( char *fn,char *crc);
STATUS  EnableHistoryHandler      ( int on );
STATUS  EnableSetPowerOffHandler  ( int on );
int     Execute                   ( void *funptr );
int     ExecuteFlasherOut         ( void *funptr,... );   // max 7 parameters
void    Format                    ( void );
STATUS  GetBootromVersion         ( char *ver );
STATUS  GetCDVersion              ( char *ver );
STATUS  GetCurrentDateClock       ( char *dc );
STATUS  GetModuleId               ( int mid,char *tid );
STATUS  GetSearchResult           ( int ndx,char *res,char *path );
STATUS  GetSourceDrive            ( char *path );
STATUS  InstallHDDTestFiles       ( void );
int     IsFpInLoader              ( void );
int     IsPartitionCaseSensitive  ( void );
int     IsPartitionUnderRepair    ( void );
void    loadFile                  ( void );
STATUS  LockCDEject               ( int on );
STATUS  ReadFileCRC               ( char *fn,char *crc );
void    RebootSystem              ( void );
int     SearchAndTargetFileExclu  ( char *fn,char *tn,char *par[],int npar,char *root,char *dir );
STATUS  SetBootLoaderFlag         ( int stayInBootLoader );
STATUS  SetMasterFlashingOn       ( void );
STATUS  SetPartitionRepairState   ( int repair );
STATUS  SetPower                  ( int on );
STATUS  SetRedLedOn               ( int on );
STATUS  SetUPGInProgressInCDD     ( int on );
STATUS  SetUpgradeLogging         ( int on );
STATUS  StopCOMModule             ( int mid );
STATUS  StopHDDActivity           ( void );
STATUS  UpdateFSImage             ( void );
STATUS  UPGCopy                   ( char *src,char *dst,int cut );
STATUS  UPGDelete                 ( char *fn );
void*   UPGFindSymbol             ( char *sym );
STATUS  UPGLogMsg                 ( char *fmt,... );

/* Functions and data types from MMI module
 */
#define NO                            0
#define YES                           1

STATUS  ClearScreen                   ( void );
STATUS  ShowNavigationBargraph        ( void );
STATUS  StepBargraph                  ( char *txt, int per );
STATUS  ShowNavigationQuestionScreen  ( char *txt, int *answ );

// Drive letters
#define DRIVE_USB       "/bd0"
#define DRIVE_HDD       "/C"
#define DRIVE_CD        "/D"
#define DRIVE_TFFS      "/F"
#define DRIVE_NAV       "/H"
#define DRIVE_USER      "/I"
#define DRIVE_JBX       "/J"


/* extra C standard function, pull out through modified Builtins.out
 */
void *pf_fread;
void *pf_fwrite;
void *pf_fseek;
void *pf_sprintf;
void *pf_memset;
void *pf_strchr;

STATUS InitFunctionPtr ( void )
{
  int   l_iAnsw;

  pf_fread    =UPGFindSymbol( "fread" );
  pf_fwrite   =UPGFindSymbol( "fwrite" );
  pf_fseek    =UPGFindSymbol( "fseek" );
  pf_sprintf  =UPGFindSymbol( "sprintf" );
  pf_memset   =UPGFindSymbol( "memset" );
  pf_strchr   =UPGFindSymbol( "strchr" );

  if( pf_fread  !=NULL &&
      pf_fwrite !=NULL &&
      pf_fseek  !=NULL &&
      pf_sprintf!=NULL &&
      pf_memset !=NULL &&
      pf_strchr !=NULL )    return OK;

  ShowNavigationQuestionScreen( "InitFunctionPtr() FAILED!", &l_iAnsw );
  return ERROR;
}

/* these functions work only on modified Builtins.out crc=19bb6041
 */
#define FREAD( ptr,size,n,fp )      ExecuteFlasherOut( pf_fread,ptr,size,n,fp )
#define FWRITE( ptr,size,n,fp )     ExecuteFlasherOut( pf_fwrite,ptr,size,n,fp )
#define FSEEK( fp,offset,from )     ExecuteFlasherOut( pf_fseek,fp,offset,from )
#define MEMSET( ptr,value,len )     ExecuteFlasherOut( pf_memset,ptr,value,len )
#define STRCHR( str,chr )    (char*)ExecuteFlasherOut( pf_strchr,str,chr )
#define EFO                         ExecuteFlasherOut

/* Other builtins Functions and data type
 */
int     UPGSearchFile       ( char *fn, char *root, char *param, char *tabledir );
STATUS  UPGGetSearchResult  ( int ndx,char *res );
STATUS  GetFileSize         ( char *fn, int *size);


/* Functions and data types for file backup managment
 */
STATUS IsBackupPresent ( char *p_sFile )
{
  FILE *l_f;
  char  l_sBak[256];
  strcpy( l_sBak,p_sFile );
  strcat( l_sBak,".bak" );
  l_f=fopen( l_sBak,"rb" );
  if( l_f==NULL )
    return FALSE;
  fclose( l_f );
  return TRUE;
}

STATUS CreateBackup ( char *p_sFile )
{
  char  l_sBak[256];
  char  l_sInf[256];
  strcpy( l_sBak,p_sFile );
  strcat( l_sBak,".bak" );
  UPGCopy( p_sFile,l_sBak,0 );
  strcpy( l_sInf,p_sFile );
  strcat( l_sInf,".inf" );
  strcpy( l_sBak,l_sInf );
  strcat( l_sBak,".bak" );
  UPGCopy( l_sInf,l_sBak,0 );
  return OK;
}

STATUS RestoreBackup ( char *p_sFile )
{
  char  l_sBak[256];
  char  l_sInf[256];
  strcpy( l_sBak,p_sFile );
  strcat( l_sBak,".bak" );
  UPGCopy( l_sBak,p_sFile,0 );
  strcpy( l_sInf,p_sFile );
  strcat( l_sInf,".inf" );
  strcpy( l_sBak,l_sInf );
  strcat( l_sBak,".bak" );
  UPGCopy( l_sBak,l_sInf,0 );
  return OK;
}

/* Functions and data types for .INF file managment
 */
void    PatchCRC ( char *p_crc )
{
  if( p_crc[0]==' ' )   p_crc[0]='0';
  if( p_crc[1]==' ' )   p_crc[1]='0';
  if( p_crc[2]==' ' )   p_crc[2]='0';
  if( p_crc[3]==' ' )   p_crc[3]='0';
}

STATUS  UpdateFileInf ( char *p_sFile )
{
  FILE *l_f;
  char  l_crc[9];
  char  l_sInf[256];

  l_crc[0]=l_crc[1]=l_crc[2]=l_crc[3]=0;
  if( ComputeCRCFile( p_sFile,l_crc+4 )!=OK )
  	return ERROR;
  PatchCRC( l_crc+4 );
  l_crc[8]='\n';
  strcpy( l_sInf,p_sFile );
  strcat( l_sInf,".inf" );
  l_f=fopen( l_sInf,"r+b" );
  if( l_f==NULL )
  {
    l_f=fopen( l_sInf,"wb" );
    if( l_f==NULL )
      return ERROR;
  }
  FWRITE( l_crc,9,1,l_f );
  fclose( l_f );
  ComputeCRCFile( l_sInf,l_crc );
  PatchCRC( l_crc );
  l_f=fopen( l_sInf,"r+b" );
  if( l_f==NULL )
    return ERROR;
  FWRITE( l_crc,4,1,l_f );
  fclose( l_f );
  return OK;
}

/* RT4SET Local functions and data types
 */
STATUS ReadFileInt ( char *p_sFile,int p_iAddr,int p_iSize,int *p_iVal )
{
  BYTE  l_bVal[4];
  FILE *l_f;

  if( p_iSize!=1 && p_iSize!=2 && p_iSize!=4 )
    return ERROR;
  l_f=fopen( p_sFile,"rb" );
  if( l_f==NULL )
    return ERROR;
  FSEEK( l_f,p_iAddr,0 );
  FREAD( l_bVal,p_iSize,1,l_f );
  fclose( l_f );
  switch( p_iSize )
  {
  case 1:
    *p_iVal=*(BYTE*)l_bVal;
    break;
  case 2:
    *p_iVal=*(WORD*)l_bVal;
    break;
  case 4:
    *p_iVal=*(DWORD*)l_bVal;
    break;
  }
  return OK;
}

STATUS WriteFileInt ( char *p_sFile,int p_iAddr,int p_iSize,int p_iVal )
{
  BYTE  l_bVal[4];
  FILE *l_f;

  switch( p_iSize )
  {
  case 1:
    *(BYTE*)l_bVal=(BYTE)p_iVal;
    break;
  case 2:
    *(WORD*)l_bVal=(WORD)p_iVal;
    break;
  case 4:
    *(DWORD*)l_bVal=(DWORD)p_iVal;
    break;
  default:
    return ERROR;
  }
  l_f=fopen( p_sFile,"r+b" );
  if( l_f==NULL )
    return ERROR;
  FSEEK( l_f,p_iAddr,0 );
  FWRITE( l_bVal,p_iSize,1,l_f );
  fclose( l_f );
  return OK;
}

int   ModifyFileInt ( char *p_sName,int p_nVal,int *p_pVal,int p_iAddr,int p_iSize,char *p_sFile )
{
  char  l_sText[256];
  int   l_i;
  int   l_iVal;
  int   l_iNew;
  int   l_iAnsw;
  int   l_iChg=NO;

  if( ReadFileInt( p_sFile,p_iAddr,p_iSize,&l_iVal )!=OK )
    return NO;
  do
  {
    l_iNew=p_pVal[0];
    for( l_i=p_nVal-1; l_i>0 ; l_i-- )
      if( l_iVal<p_pVal[l_i] )
        l_iNew=p_pVal[l_i];

    EFO( pf_sprintf,l_sText,"%s=%d. Set to %d?",p_sName,l_iVal,l_iNew );
    ShowNavigationQuestionScreen( l_sText, &l_iAnsw );
    if( l_iAnsw==YES )
    {
      WriteFileInt( p_sFile,p_iAddr,p_iSize,l_iNew );
      l_iVal=l_iNew;
      l_iChg=YES;
    }
  }
  while( l_iAnsw==YES && p_nVal>2 );
  return l_iChg;
}

int   UserComVersion ( char *p_sFile )
{
  int l_iSize;
  if( GetFileSize( p_sFile,&l_iSize )!=OK )
    return ERROR;
  return l_iSize;
}

#define RT4_702_USERCOM         38708
#define RT4_711_USERCOM         29936
#define RT5_800_USERCOM         52888
#define RT5_810_USERCOM         55812
#define RT5_810M_USERCOM        55936
#define RTx_811_USERCOM         55812
#define RTx_820_USERCOM         55832

int g_01[]={ 0,1};
int g_0123[]={ 0,1,2,3 };
int g_spd[]={ 5,225 };
int g_trip[]={ 0,1,2,3 };
int g_vmf[]={ 0,1,2 };
int g_beep[]={ 1,4,7 };

#define VALTAB(t)     sizeof(t)/sizeof(*t),t

int   RT_general ( char *p_sUserCom,int p_iBase )
{
   return ModifyFileInt( "Video speed"       ,VALTAB(g_spd),p_iBase+  0+0,1,p_sUserCom ) ;
}

int   RT_audio ( char *p_sUserCom,int p_iBase )
{
   return ModifyFileInt( "Ampli present"     ,VALTAB(g_01),  p_iBase+  0+0,1,p_sUserCom ) |
          ModifyFileInt( "Front Beep"        ,VALTAB(g_beep),p_iBase+ 37+0,1,p_sUserCom ) |
          ModifyFileInt( "Rear Beep"         ,VALTAB(g_beep),p_iBase+ 38+0,1,p_sUserCom ) |
        ( p_iBase>=6898 &&
          ModifyFileInt( "Arkamys"           ,VALTAB(g_01),  p_iBase+ 46+0,1,p_sUserCom ) );
}

int   RT_keyboard ( char *p_sUserCom,int p_iBase )
{
   return ModifyFileInt( "E call enable"     ,VALTAB(g_01),p_iBase+16+3,1,p_sUserCom ) |
          ModifyFileInt( "B call enable"     ,VALTAB(g_01),p_iBase+20+3,1,p_sUserCom ) ;
}

int   RT_menu ( char *p_sUserCom,int p_iBase )
{
   return ModifyFileInt( "Audio aux in"      ,VALTAB(g_01),p_iBase+244+3,1,p_sUserCom ) ;
}

int   RT_trip ( char *p_sUserCom,int p_iBase )
{
   return ModifyFileInt( "Active Trip Page"  ,VALTAB(g_trip),p_iBase+ 32+0,1,p_sUserCom ) |
          ModifyFileInt( "D295"              ,VALTAB(g_01),  p_iBase+ 36+3,1,p_sUserCom ) |
          ModifyFileInt( "D296"              ,VALTAB(g_01),  p_iBase+ 40+3,1,p_sUserCom ) |
          ModifyFileInt( "OBD page"          ,VALTAB(g_01),  p_iBase+ 44+3,1,p_sUserCom ) |
          ModifyFileInt( "TRIP page"         ,VALTAB(g_01),  p_iBase+ 48+3,1,p_sUserCom ) |
          ModifyFileInt( "Diagnostic menu"   ,VALTAB(g_01),  p_iBase+ 52+3,1,p_sUserCom ) |
          ModifyFileInt( "Service list menu" ,VALTAB(g_01),  p_iBase+ 56+3,1,p_sUserCom ) ;
}

int   RT_van ( char *p_sUserCom,int p_iBase )
{
   return ModifyFileInt( "CD Changer"        ,VALTAB(g_01),p_iBase+ 0+3,1,p_sUserCom ) |
          ModifyFileInt( "CDT"               ,VALTAB(g_01),p_iBase+ 4+3,1,p_sUserCom ) |
          ModifyFileInt( "B323"              ,VALTAB(g_01),p_iBase+ 8+0,1,p_sUserCom ) |
          ModifyFileInt( "B324"              ,VALTAB(g_01),p_iBase+ 9+0,1,p_sUserCom ) |
          ModifyFileInt( "B325"              ,VALTAB(g_01),p_iBase+10+0,1,p_sUserCom ) |
          ModifyFileInt( "B326"              ,VALTAB(g_01),p_iBase+11+0,1,p_sUserCom ) |
          ModifyFileInt( "B327"              ,VALTAB(g_01),p_iBase+12+0,1,p_sUserCom ) |
          ModifyFileInt( "B328"              ,VALTAB(g_01),p_iBase+13+0,1,p_sUserCom ) |
          ModifyFileInt( "DSG"               ,VALTAB(g_01),p_iBase+16+3,1,p_sUserCom ) |
          ModifyFileInt( "D330"              ,VALTAB(g_01),p_iBase+20+3,1,p_sUserCom ) |
          ModifyFileInt( "VTH"               ,VALTAB(g_01),p_iBase+24+3,1,p_sUserCom ) |
          ModifyFileInt( "D332"              ,VALTAB(g_01),p_iBase+28+3,1,p_sUserCom ) |
          ModifyFileInt( "Reset Tire U.P."   ,VALTAB(g_01),p_iBase+32+3,1,p_sUserCom ) |
          ModifyFileInt( "D334"              ,VALTAB(g_01),p_iBase+36+3,1,p_sUserCom ) |
          ModifyFileInt( "D335"              ,VALTAB(g_01),p_iBase+40+3,1,p_sUserCom ) |
          ModifyFileInt( "Visual park assist",VALTAB(g_01),p_iBase+44+3,1,p_sUserCom ) |
          ModifyFileInt( "Rear park assist"  ,VALTAB(g_01),p_iBase+48+3,1,p_sUserCom ) |
          ModifyFileInt( "Front park assist" ,VALTAB(g_01),p_iBase+52+3,1,p_sUserCom ) |
          ModifyFileInt( "D339"              ,VALTAB(g_01),p_iBase+56+3,1,p_sUserCom ) |
          ModifyFileInt( "Hydr.susp.frame"   ,VALTAB(g_01),p_iBase+60+0,1,p_sUserCom ) |
          ModifyFileInt( "EMF config"        ,VALTAB(g_01),p_iBase+64+3,1,p_sUserCom ) |
          ModifyFileInt( "VMF/VCCF"          ,VALTAB(g_vmf),p_iBase+68+3,1,p_sUserCom ) ;
}

int   RT_video ( char *p_sUserCom,int p_iBase )
{
   return ModifyFileInt( "D353"              ,VALTAB(g_01),p_iBase+ 0+3,1,p_sUserCom ) |
          ModifyFileInt( "D354"              ,VALTAB(g_01),p_iBase+ 4+3,1,p_sUserCom ) |
          ModifyFileInt( "D355"              ,VALTAB(g_01),p_iBase+ 8+3,1,p_sUserCom ) |
          ModifyFileInt( "Video 1 in"        ,VALTAB(g_01),p_iBase+12+3,1,p_sUserCom ) |
          ModifyFileInt( "D357"              ,VALTAB(g_01),p_iBase+16+3,1,p_sUserCom ) |
          ModifyFileInt( "D358"              ,VALTAB(g_01),p_iBase+20+3,1,p_sUserCom ) ;
}

int   RT_AirC ( char *p_sUserCom,int p_iBase )
{
   return ModifyFileInt( "Turn off L/R reg"  ,VALTAB(g_01),p_iBase+ 0+3,1,p_sUserCom ) |
          ModifyFileInt( "A/C menu"          ,VALTAB(g_01),p_iBase+ 4+3,1,p_sUserCom ) |
          ModifyFileInt( "D387"              ,VALTAB(g_01),p_iBase+ 8+3,1,p_sUserCom ) |
          ModifyFileInt( "D388"              ,VALTAB(g_01),p_iBase+12+3,1,p_sUserCom ) ;
}

int   RT_Vconf ( char *p_sUserCom,int p_iBase )
{
   return ModifyFileInt( "Overtake help"     ,VALTAB(g_0123),p_iBase+ 0+3,1,p_sUserCom ) |
          ModifyFileInt( "Near obstacle det" ,VALTAB(g_0123),p_iBase+ 4+3,1,p_sUserCom ) |
          ModifyFileInt( "Driver wellcome"   ,VALTAB(g_01),p_iBase+ 8+3,1,p_sUserCom ) |
          ModifyFileInt( "Boot perm locking" ,VALTAB(g_01),p_iBase+12+3,1,p_sUserCom ) |
          ModifyFileInt( "Remote doors lock" ,VALTAB(g_01),p_iBase+16+3,1,p_sUserCom ) |
          ModifyFileInt( "Adaptable light"   ,VALTAB(g_01),p_iBase+20+3,1,p_sUserCom ) |
          ModifyFileInt( "Auto headlight"    ,VALTAB(g_01),p_iBase+24+3,1,p_sUserCom ) |
          ModifyFileInt( "Automatic brake"   ,VALTAB(g_01),p_iBase+28+3,1,p_sUserCom ) |
          ModifyFileInt( "Conf.Light menu"   ,VALTAB(g_01),p_iBase+32+3,1,p_sUserCom ) |
          ModifyFileInt( "Ambient light"     ,VALTAB(g_01),p_iBase+36+3,1,p_sUserCom ) |
          ModifyFileInt( "Rear wiper"        ,VALTAB(g_01),p_iBase+40+3,1,p_sUserCom ) |
          ModifyFileInt( "Securoscope"       ,VALTAB(g_01),p_iBase+44+3,1,p_sUserCom ) |
          ModifyFileInt( "Doors selectivity" ,VALTAB(g_01),p_iBase+48+3,1,p_sUserCom ) |
          ModifyFileInt( "Diurnal headlight" ,VALTAB(g_01),p_iBase+52+3,1,p_sUserCom ) |
          ModifyFileInt( "COE locking mode"  ,VALTAB(g_01),p_iBase+56+3,1,p_sUserCom ) |
          ModifyFileInt( "Window partial open",VALTAB(g_01),p_iBase+60+3,1,p_sUserCom ) |
          ModifyFileInt( "D417"              ,VALTAB(g_01),p_iBase+64+3,1,p_sUserCom ) |
          ModifyFileInt( "D418"              ,VALTAB(g_01),p_iBase+68+3,1,p_sUserCom ) |
          ModifyFileInt( "Driving assistance",VALTAB(g_01),p_iBase+72+3,1,p_sUserCom ) |
          ModifyFileInt( "D420"              ,VALTAB(g_01),p_iBase+76+3,1,p_sUserCom ) |
          ModifyFileInt( "D421"              ,VALTAB(g_01),p_iBase+80+3,1,p_sUserCom ) |
          ModifyFileInt( "D422"              ,VALTAB(g_01),p_iBase+84+3,1,p_sUserCom ) |
          ModifyFileInt( "D423"              ,VALTAB(g_01),p_iBase+88+3,1,p_sUserCom ) |
          ModifyFileInt( "D424"              ,VALTAB(g_01),p_iBase+92+3,1,p_sUserCom ) ;
}

int   RT_display ( char *p_sUserCom,int p_iBase )
{
   return  ModifyFileInt( "External temp"    ,VALTAB(g_01),  p_iBase+ 0+3,1,p_sUserCom ) |
           ModifyFileInt( "Conf"             ,VALTAB(g_0123),p_iBase+ 4+3,1,p_sUserCom ) ;
}

int   RT_diag ( char *p_sUserCom,int p_iBase )
{
   return  ModifyFileInt( "Speed limit"      ,VALTAB(g_01),p_iBase+136+3,1,p_sUserCom ) |
           ModifyFileInt( "Speed trap"       ,VALTAB(g_01),p_iBase+140+3,1,p_sUserCom ) ;
}

int   main ( int argc,char *argv[] )
{
  int   l_iS032General;
  int   l_iS080Audio;
  int   l_iS160Keybrd;
  int   l_iS176Menu;
  int   l_iS288Trip;
  int   l_iS320VAN;
  int   l_iS352Video;
  int   l_iS384AirC;
  int   l_iS400Vconf;
  int   l_iS432Display;
  int   l_iS448Diag;
  int   l_iMdfy=NO;
  int   l_iAnsw=NO;
  char  l_sUserCom[256];
  char  l_sUserComTmp[256];


  if( InitFunctionPtr()==OK )
  {
    strcpy( l_sUserCom,DRIVE_USER "/USER_DATA/User_profile/User_com.dat" );

    if( IsBackupPresent( l_sUserCom )==TRUE )
    {
      ShowNavigationQuestionScreen( "Restore user_com.dat?",&l_iAnsw );
      if( l_iAnsw==YES )
        RestoreBackup( l_sUserCom );
    }
    if( l_iAnsw==NO )
    {
      ShowNavigationQuestionScreen( "Backup user_com.dat?",&l_iAnsw );
      if( l_iAnsw==YES )
        CreateBackup( l_sUserCom );
    }

    strcpy( l_sUserComTmp,l_sUserCom );
    strcat( l_sUserComTmp,".tmp" );
    UPGCopy( l_sUserCom,l_sUserComTmp,0 );

    switch( UserComVersion( l_sUserComTmp ) )
    {
    case RT4_702_USERCOM:
      l_iS032General=5788+    0;
      l_iS080Audio  =5788+  224;
      l_iS160Keybrd =5788+  352;
      l_iS176Menu   =5788+  392;
      l_iS288Trip   =5788+22704;
      l_iS320VAN    =5788+22772;
      l_iS352Video  =5788+22832;
      l_iS384AirC   =5788+22912;
      l_iS400Vconf  =5788+22960;
      l_iS432Display=5788+23056;
      l_iS448Diag   =0;
      break;
    case RT4_711_USERCOM:
      l_iS032General=5836+    0;
      l_iS080Audio  =5836+  228;
      l_iS160Keybrd =5836+  572;
      l_iS176Menu   =5836+  612;
      l_iS288Trip   =5836+23240;
      l_iS320VAN    =5836+23308;
      l_iS352Video  =5836+23380;
      l_iS384AirC   =5836+23460;
      l_iS400Vconf  =5836+23508;
      l_iS432Display=5836+23604;
      l_iS448Diag   =0;
      break;
    case RT5_800_USERCOM:
      l_iS032General=6636+    0;
      l_iS080Audio  =6636+  232;
      l_iS160Keybrd =6636+  576;
      l_iS176Menu   =6636+  620;
      l_iS288Trip   =6636+40380;
      l_iS320VAN    =6636+40456;
      l_iS352Video  =6636+40528;
      l_iS384AirC   =6636+40608;
      l_iS400Vconf  =6636+40656;
      l_iS432Display=6636+40752;
      l_iS448Diag   =0;
      break;
    case RT5_810_USERCOM:
//    case RTx_811_USERCOM:
      l_iS032General=7164+    0;
      l_iS080Audio  =7164+  236;
      l_iS160Keybrd =7164+  580;
      l_iS176Menu   =7164+  684;
      l_iS288Trip   =7164+40444;
      l_iS320VAN    =7164+40520;
      l_iS352Video  =7164+40592;
      l_iS384AirC   =7164+40672;
      l_iS400Vconf  =7164+40720;
      l_iS432Display=7164+40816;
      l_iS448Diag   =7164+40824;
      break;
	case RT5_810M_USERCOM:
      l_iS032General=7260+    0;
      l_iS080Audio  =7260+  236;
      l_iS160Keybrd =7260+  584;
      l_iS176Menu   =7260+  688;
      l_iS288Trip   =7260+40448;
      l_iS320VAN    =7260+40524;
      l_iS352Video  =7260+40596;
      l_iS384AirC   =7260+40676;
      l_iS400Vconf  =7260+40724;
      l_iS432Display=7260+40820;
      l_iS448Diag   =7260+40828;
      break;
    case RTx_820_USERCOM:
      l_iS032General=7180+    0;
      l_iS080Audio  =7180+  236;
      l_iS160Keybrd =7180+  580;
      l_iS176Menu   =7180+  684;
      l_iS288Trip   =7180+40444;
      l_iS320VAN    =7180+40520;
      l_iS352Video  =7180+40592;
      l_iS384AirC   =7180+40672;
      l_iS400Vconf  =7180+40720;
      l_iS432Display=7180+40816;
      l_iS448Diag   =7180+40824;
      break;
    default:
      ShowNavigationQuestionScreen( "Unknown USER_COM.DAT version!",&l_iAnsw );
      ClearScreen();
      return OK;
    }

    do
    {
      ShowNavigationQuestionScreen( "view/modify GENERAL section ?",&l_iAnsw );
      if( l_iAnsw==YES )
        l_iMdfy |= RT_general( l_sUserComTmp,l_iS032General );

      ShowNavigationQuestionScreen( "view/modify AUDIO section ?",&l_iAnsw );
      if( l_iAnsw==YES )
        l_iMdfy |= RT_audio( l_sUserComTmp,l_iS080Audio );

      ShowNavigationQuestionScreen( "view/modify KEYBOARD section ?",&l_iAnsw );
      if( l_iAnsw==YES )
        l_iMdfy |= RT_keyboard( l_sUserComTmp,l_iS160Keybrd );

      ShowNavigationQuestionScreen( "view/modify MENU section ?",&l_iAnsw );
      if( l_iAnsw==YES )
        l_iMdfy |= RT_menu( l_sUserComTmp,l_iS176Menu );

      ShowNavigationQuestionScreen( "view/modify TRIP section ?",&l_iAnsw );
      if( l_iAnsw==YES )
        l_iMdfy |= RT_trip( l_sUserComTmp,l_iS288Trip );

      ShowNavigationQuestionScreen( "view/modify VAN section ?",&l_iAnsw );
      if( l_iAnsw==YES )
        l_iMdfy |= RT_van( l_sUserComTmp,l_iS320VAN );

      ShowNavigationQuestionScreen( "view/modify VIDEO section ?",&l_iAnsw );
      if( l_iAnsw==YES )
        l_iMdfy |= RT_video( l_sUserComTmp,l_iS352Video );

      ShowNavigationQuestionScreen( "view/modify AIRC section ?",&l_iAnsw );
      if( l_iAnsw==YES )
        l_iMdfy |= RT_AirC( l_sUserComTmp,l_iS384AirC );

      ShowNavigationQuestionScreen( "view/modify VEICLE CONF section ?",&l_iAnsw );
      if( l_iAnsw==YES )
        l_iMdfy |= RT_Vconf( l_sUserComTmp,l_iS400Vconf );

      ShowNavigationQuestionScreen( "view/modify DISPLAY section ?",&l_iAnsw );
      if( l_iAnsw==YES )
        l_iMdfy |= RT_display( l_sUserComTmp,l_iS432Display );

      if( l_iS448Diag )
      {
        ShowNavigationQuestionScreen( "view/modify DIAG section ?",&l_iAnsw );
        if( l_iAnsw==YES )
          l_iMdfy |= RT_diag( l_sUserComTmp,l_iS448Diag );
      }

      ShowNavigationQuestionScreen( "view/modify again ?",&l_iAnsw );
    }
    while( l_iAnsw==YES );

    if( l_iMdfy==NO )
      ShowNavigationQuestionScreen( "Nothing changed",&l_iAnsw );
    else
    {
      if( UpdateFileInf( l_sUserComTmp )!=OK )
        ShowNavigationQuestionScreen( "File .INF creation error.",&l_iAnsw );
      else
      {
        UPGCopy( l_sUserComTmp,l_sUserCom,1 );
        strcat( l_sUserCom,".inf" );
        strcat( l_sUserComTmp,".inf" );
        UPGCopy( l_sUserComTmp,l_sUserCom,1 );
        ShowNavigationQuestionScreen( "RTxSET Terminated! Reboot ?",&l_iAnsw );
        if( l_iAnsw==YES )
          RebootSystem();
      }
    }
  }
  ClearScreen();
  return OK;
}
