/*
 * SMS.CMD  by mira308sw
 *
 * WARNING!:
 *  this script work only with modified version of Builtins.out crc=19bb6041
 *  in which the function ExecuteFlasherOut can pass to called funptr till to
 *  seven integers (or addresses) parameters
 *
 * SMS is a script to save received sms, saved on RTX system to USB.
 * it write in  a new folder /SMS one text file for each sms.
 * text file have a name composed by received date&time plus phone number.
 *
 * v01.00 : 22/01/2009  first release
 */

/* Functions and data types from Integrated C Interpreter
 */
typedef unsigned char           BYTE;
typedef unsigned short          WORD;
typedef unsigned long           DWORD;

typedef int                     BOOL;

typedef void                    DIR;
typedef void                    FILE;

typedef enum { ERROR=-1,OK=0 }  STATUS;

#define NULL                    (void*)0
#define TRUE                    1
#define FALSE                   0

int     atoi                    ( char *s );
STATUS  close                   ( int hf );
STATUS  closedir                ( DIR *d );
STATUS  EiC_ExeFile             ( int argc,char **argv );
STATUS  fclose                  ( FILE *f );
STATUS  feof                    ( FILE *f );
char*   fgets                   ( char *s,int max,FILE *f );
FILE*   fopen                   ( char *fn,char *mode );
STATUS  fputs                   ( char *s,FILE *f );
void    free                    ( void *mem );
void    loadModule              ( int hf,int mode );
STATUS  logMsg                  ( char *fmt,...);
void*   malloc                  ( int size );
STATUS  mv                      ( char *src,char *dest );
int     open                    ( char *fn,int access,int mode );
DIR*    opendir                 ( char *dn );
int     putchar                 ( int c );
char*   strcat                  ( char *dest,char *s );
int     strcmp                  ( char *s1,char *s2 );
char*   strcpy                  ( char *dest,char *src );
int     strlen                  ( char *s );
int     strncmp                 ( char *s1,char *s2,int max );
char*   strrchr                 ( char *s,int c );
char*   strstr                  ( char *s1,char *s2 );
void    taskDelay               ( int tick );
DWORD   tickGet                 ( void );
STATUS  xcopy                   ( char *src,char *dest );
STATUS  xdelete                 ( char *src );

/* functions not yet known (for me)
 *
void    copy                    ( void );
void    creat                   ( void );
void    ExeScriptFile           ( void );
void    moduleFindByNameAndPath ( void );
void    rm                      ( void );
void    sqrt                    ( void );
void    symFindByNameAndType    ( void );
void    unldByModuleId          ( void );
void    unldByNameAndPath       ( void );
 */

/* Funcions and data type from modified builtins.out crc=19bb6041
 */

#define LOAD_NO_SYMBOLS         2
#define LOAD_LOCAL_SYMBOLS      4
#define LOAD_GLOBAL_SYMBOLS     8
#define LOAD_ALL_SYMBOLS        (LOAD_LOCAL_SYMBOLS|LOAD_GLOBAL_SYMBOLS)

void    AddGatewayHistory         ( void );
STATUS  AddUPGHistoryHeader       ( char *cd,char *target,char *action );
STATUS  BootRomFormatTffs         ( void );
void    CheckCRCDrive             ( void );
STATUS  CheckCRCFile              ( char *fn );
STATUS  ComputeCRCFile            ( char *fn,char *crc);
STATUS  EnableHistoryHandler      ( int on );
STATUS  EnableSetPowerOffHandler  ( int on );
int     Execute                   ( void *funptr );
int     ExecuteFlasherOut         ( void *funptr,... );   // max 7 parameters
void    Format                    ( void );
STATUS  GetBootromVersion         ( char *ver );
STATUS  GetCDVersion              ( char *ver );
STATUS  GetCurrentDateClock       ( char *dc );
STATUS  GetModuleId               ( int mid,char *tid );
STATUS  GetSearchResult           ( int ndx,char *res,char *path );
STATUS  GetSourceDrive            ( char *path );
STATUS  InstallHDDTestFiles       ( void );
int     IsFpInLoader              ( void );
int     IsPartitionCaseSensitive  ( void );
int     IsPartitionUnderRepair    ( void );
void    loadFile                  ( void );
STATUS  LockCDEject               ( int on );
STATUS  ReadFileCRC               ( char *fn,char *crc );
void    RebootSystem              ( void );
int     SearchAndTargetFileExclu  ( char *fn,char *tn,char *par[],int npar,char *root,char *dir );
STATUS  SetBootLoaderFlag         ( int stayInBootLoader );
STATUS  SetMasterFlashingOn       ( void );
STATUS  SetPartitionRepairState   ( int repair );
STATUS  SetPower                  ( int on );
STATUS  SetRedLedOn               ( int on );
STATUS  SetUPGInProgressInCDD     ( int on );
STATUS  SetUpgradeLogging         ( int on );
STATUS  StopCOMModule             ( int mid );
STATUS  StopHDDActivity           ( void );
STATUS  UpdateFSImage             ( void );
STATUS  UPGCopy                   ( char *src,char *dst,int cut );
STATUS  UPGDelete                 ( char *fn );
void*   UPGFindSymbol             ( char *sym );
STATUS  UPGLogMsg                 ( char *fmt,... );

/* Functions and data types from MMI module
 */
#define NO                            0
#define YES                           1

STATUS  ClearScreen                   ( void );
STATUS  ShowNavigationBargraph        ( void );
STATUS  StepBargraph                  ( char *txt, int per );
STATUS  ShowNavigationQuestionScreen  ( char *txt, int *answ );

/* Functions and data types for RTx system
 */
// Drive letters
#define DRIVE_USB       "/bd0"
#define DRIVE_HDD       "/C"
#define DRIVE_CD        "/D"
#define DRIVE_TFFS      "/F"
#define DRIVE_NAV       "/H"
#define DRIVE_USER      "/I"
#define DRIVE_JBX       "/J"


/* extra C standard function, pull out through modified Builtins.out
 */

void *pf_fread;
void *pf_fwrite;
void *pf_fseek;
void *pf_sprintf;
void *pf_memset;
void *pf_memmove;
void *pf_strchr;
void *pf_stricmp;

STATUS InitFunctionPtr ( void )
{
  int   l_iAnsw;

  pf_fread    =UPGFindSymbol( "fread" );
  pf_fwrite   =UPGFindSymbol( "fwrite" );
  pf_fseek    =UPGFindSymbol( "fseek" );
  pf_sprintf  =UPGFindSymbol( "sprintf" );
  pf_memset   =UPGFindSymbol( "memset" );
  pf_memmove  =UPGFindSymbol( "memmove" );
  pf_strchr   =UPGFindSymbol( "strchr" );
  pf_stricmp  =UPGFindSymbol( "LH_stricmp" );

  if( pf_fread  !=NULL &&
      pf_fwrite !=NULL &&
      pf_fseek  !=NULL &&
      pf_sprintf!=NULL &&
      pf_memset !=NULL &&
      pf_memmove!=NULL &&
      pf_strchr !=NULL &&
      pf_stricmp!=NULL )    return OK;

  ShowNavigationQuestionScreen( "InitFunctionPtr() FAILED!", &l_iAnsw );
  return ERROR;
}

/* these functions work only on modified Builtins.out crc=19bb6041
 */
#define FREAD( ptr,size,n,fp )      ExecuteFlasherOut( pf_fread,ptr,size,n,fp )
#define FWRITE( ptr,size,n,fp )     ExecuteFlasherOut( pf_fwrite,ptr,size,n,fp )
#define FSEEK( fp,offset,from )     ExecuteFlasherOut( pf_fseek,fp,offset,from )
#define MEMSET( ptr,value,len )     ExecuteFlasherOut( pf_memset,ptr,value,len )
#define MEMMOVE( dst,src,len )      ExecuteFlasherOut( pf_memmove,dst,src,len )
#define STRCHR( str,chr )    (char*)ExecuteFlasherOut( pf_strchr,str,chr )
#define STRICMP( s1,s2 )            ExecuteFlasherOut( pf_stricmp,s1,s2 )
#define EFO                         ExecuteFlasherOut

/* Other builtins Functions and data type
 */
int     UPGSearchFile       ( char *fn, char *root, char *param, char *tabledir );
STATUS  UPGGetSearchResult  ( int ndx,char *res );
STATUS  UPGMKDir            ( char *dir);
STATUS  UPGMKDelete         ( char *dir);
STATUS  GetFileSize         ( char *fn, int *size);


#define SMS_711             8004
#define SMS_800             8164
#define SMS_810             8484

#define SMS_SAVEDIR         DRIVE_USB "/SMS"
#define SMS_BOOKFILE        DRIVE_USER "/USER_DATA/Phone/SMS_book.dat"

typedef struct header
{
  BYTE    tot;
  BYTE    dummy[3];
} t_hdr;

typedef struct date
{
  BYTE    hh,mm,ss;
  BYTE    DD,MM,YY;
} t_date;

typedef struct sms_711
{
  DWORD   unk_1;
  DWORD   flag;
  t_date  date;
  BYTE    _1[1];
  char    number[22];
  BYTE    tlen;
  char    text[160];
  BYTE    dummy[2];
} t_sms_711;

typedef struct sms_800
{
  DWORD   unk_1;
  DWORD   flag;
  t_date  date;
  BYTE    _1[2];
  DWORD   unk_2;
  char    number[22];
  BYTE    tlen;
  char    text[160];
  BYTE    _2[1];
} t_sms_800;

typedef struct sms_810
{
  DWORD   unk_1;
  DWORD   flag;
  t_date  date;
  BYTE    _1[2];
  DWORD   unk_2;
  char    number[22];
  WORD    tlen;
  char    text[164];
  DWORD   unk_3;
} t_sms_810;

int   GetSMS_711 ( FILE *p_f,char *p_sFile,char *p_sText )
{
  char  l_sDate[32];
  char  l_sTime[32];
  t_sms_711 l_sms;

  FREAD( &l_sms,sizeof( l_sms ),1,p_f );

  EFO( pf_sprintf,l_sDate,"%02d%02d%02d",l_sms.date.YY,l_sms.date.MM,l_sms.date.DD );
  EFO( pf_sprintf,l_sTime,"%02d%02d%02d",l_sms.date.hh,l_sms.date.mm,l_sms.date.ss );
  if( l_sms.number[0]=='+' )
    EFO( pf_sprintf,p_sFile,SMS_SAVEDIR "/%s-%s-00%s.txt",l_sDate,l_sTime,l_sms.number+1 );
  else
    EFO( pf_sprintf,p_sFile,SMS_SAVEDIR "/%s-%s-%s.txt",l_sDate,l_sTime,l_sms.number );

  strcpy( p_sText,l_sms.text );
  return OK;
}

int   GetSMS_800 ( FILE *p_f,char *p_sFile,char *p_sText )
{
  char  l_sDate[32];
  char  l_sTime[32];
  t_sms_800 l_sms;

  FREAD( &l_sms,sizeof( l_sms ),1,p_f );

  EFO( pf_sprintf,l_sDate,"%02d%02d%02d",l_sms.date.YY,l_sms.date.MM,l_sms.date.DD );
  EFO( pf_sprintf,l_sTime,"%02d%02d%02d",l_sms.date.hh,l_sms.date.mm,l_sms.date.ss );
  if( l_sms.number[0]=='+' )
    EFO( pf_sprintf,p_sFile,SMS_SAVEDIR "/%s-%s-00%s.txt",l_sDate,l_sTime,l_sms.number+1 );
  else
    EFO( pf_sprintf,p_sFile,SMS_SAVEDIR "/%s-%s-%s.txt",l_sDate,l_sTime,l_sms.number );

  strcpy( p_sText,l_sms.text );
  return OK;
}

int   GetSMS_810 ( FILE *p_f,char *p_sFile,char *p_sText )
{
  char  l_sDate[32];
  char  l_sTime[32];
  t_sms_810 l_sms;

  FREAD( &l_sms,sizeof( l_sms ),1,p_f );

  EFO( pf_sprintf,l_sDate,"%02d%02d%02d",l_sms.date.YY,l_sms.date.MM,l_sms.date.DD );
  EFO( pf_sprintf,l_sTime,"%02d%02d%02d",l_sms.date.hh,l_sms.date.mm,l_sms.date.ss );
  if( l_sms.number[0]=='+' )
    EFO( pf_sprintf,p_sFile,SMS_SAVEDIR "/%s-%s-00%s.txt",l_sDate,l_sTime,l_sms.number+1 );
  else
    EFO( pf_sprintf,p_sFile,SMS_SAVEDIR "/%s-%s-%s.txt",l_sDate,l_sTime,l_sms.number );

  strcpy( p_sText,l_sms.text );
  return OK;
}

int   GetTypeSMS ( void )
{
  int   l_iType;
  if( GetFileSize( SMS_BOOKFILE,&l_iType )==OK )
    return l_iType;
  return 0;
}

int   SaveSMS ( char *p_sFile,char *p_sText )
{
  FILE *l_f=fopen( p_sFile,"wb" );
  if( l_f==NULL )
    return ERROR;
  fputs( p_sText,l_f );
  fclose( l_f );
  return OK;
}

int   main ( int argc,char *argv[] )
{
  int   l_iType;
  int   l_i;
  int   l_iAnsw = FALSE;
  FILE *l_f;
  char  l_sFile[256];
  char  l_sText[256];
  t_hdr l_hdr;

  if( InitFunctionPtr()!=OK )
    return OK;

  l_iType=GetTypeSMS();
  switch( l_iType )
  {
  case SMS_711:
  case SMS_800:
  case SMS_810:
    break;
  default:
    return ShowNavigationQuestionScreen( "Unknown SMSbook.dat file",&l_iAnsw );
  }

  UPGMKDir( SMS_SAVEDIR );

  l_f=fopen( SMS_BOOKFILE,"rb" );
  if( l_f==NULL )
    return ShowNavigationQuestionScreen( "Unable to open SMSbook.dat",&l_iAnsw );

  FREAD( &l_hdr,sizeof( l_hdr ),1,l_f );
  for( l_i=0 ; l_i<l_hdr.tot ; l_i++ )
  {
    ShowNavigationBargraph();
    StepBargraph( "Save SMS",100*(l_i+1)/l_hdr.tot );
    taskDelay( 100 );
    switch( l_iType )
    {
    case SMS_711:
      GetSMS_711( l_f,l_sFile,l_sText );
      break;
    case SMS_800:
      GetSMS_800( l_f,l_sFile,l_sText );
      break;
    case SMS_810:
      GetSMS_810( l_f,l_sFile,l_sText );
      break;
    }
    SaveSMS( l_sFile,l_sText );
  }
  fclose( l_f );
  return ShowNavigationQuestionScreen( "Finish!",&l_iAnsw );
}