/*
 * RTxSET.CMD by mira308sw
 * French Translation by Pierre
 *
 * WARNING!:
 *  this script work only with modified version of Builtins.out crc=19bb6041
 *  in which the function ExecuteFlasherOut can pass to called funptr till to
 *  seven integers (or addresses) parameters
 *
 * Either RT4 and RT5 are supported.
 *
 * before start is possible to do a backup/restore of current user_com.dat file.
 * user is prompted sequencially to choice if change or not some settings.
 * at the end reboot the system to the change take in effect.
 *
 * v 01.00: 26/12/2008  first realease
 * v 01.01: 06/01/2009  add sw:7.02 support
 * v 02.01: 07/01/2009  add sw:8.10 support, add more items divided in sections
 * v 02.02: 10/01/2009  add some definitions
 * v 02.10: 18/01/2009  work on tmp file to avoid damage if something goes wrong
 * v 02.30: 15/03/2009  add some item definition
 */

/* Functions and data types from Integrated C Interpreter
 */
typedef unsigned char           BYTE;
typedef unsigned short          WORD;
typedef unsigned long           DWORD;

typedef int                     BOOL;

typedef void                    DIR;
typedef void                    FILE;

typedef enum { ERROR=-1,OK=0 }  STATUS;

#define LOAD_NO_SYMBOLS         2
#define LOAD_LOCAL_SYMBOLS      4
#define LOAD_GLOBAL_SYMBOLS     8
#define LOAD_ALL_SYMBOLS        (LOAD_LOCAL_SYMBOLS|LOAD_GLOBAL_SYMBOLS)

#define NULL                    (void*)0

#define TRUE                    1
#define FALSE                   0

int     atoi                    ( char *s );
STATUS  close                   ( int hf );
STATUS  closedir                ( DIR *d );
STATUS  EiC_ExeFile             ( int argc,char **argv );
STATUS  fclose                  ( FILE *f );
STATUS  feof                    ( FILE *f );
char*   fgets                   ( char *s,int max,FILE *f );
FILE*   fopen                   ( char *fn,char *mode );
STATUS  fputs                   ( char *s,FILE *f );
void    free                    ( void *mem );
void    loadModule              ( int hf,int mode );
STATUS  logMsg                  ( char *fmt,...);
void*   malloc                  ( int size );
STATUS  mv                      ( char *src,char *dest );
int     open                    ( char *fn,int access,int mode );
DIR*    opendir                 ( char *dn );
int     putchar                 ( int c );
char*   strcat                  ( char *dest,char *s );
int     strcmp                  ( char *s1,char *s2 );
char*   strcpy                  ( char *dest,char *src );
int     strlen                  ( char *s );
int     strncmp                 ( char *s1,char *s2,int max );
char*   strrchr                 ( char *s,int c );
char*   strstr                  ( char *s1,char *s2 );
void    taskDelay               ( int tick );
DWORD   tickGet                 ( void );
STATUS  xcopy                   ( char *src,char *dest );
STATUS  xdelete                 ( char *src );

/* functions not yet known (for me)
 *
void    copy                    ( void );
void    creat                   ( void );
void    ExeScriptFile           ( void );
void    moduleFindByNameAndPath ( void );
void    rm                      ( void );
void    sqrt                    ( void );
void    symFindByNameAndType    ( void );
void    unldByModuleId          ( void );
void    unldByNameAndPath       ( void );
 */

/* Funcions and data type from modified builtins.out crc=19bb6041
 */
void    AddGatewayHistory         ( void );
STATUS  AddUPGHistoryHeader       ( char *cd,char *target,char *action );
STATUS  BootRomFormatTffs         ( void );
void    CheckCRCDrive             ( void );
STATUS  CheckCRCFile              ( char *fn );
STATUS  ComputeCRCFile            ( char *fn,char *crc);
STATUS  EnableHistoryHandler      ( int on );
STATUS  EnableSetPowerOffHandler  ( int on );
int     Execute                   ( void *funptr );
int     ExecuteFlasherOut         ( void *funptr,... );   // max 7 parameters
void    Format                    ( void );
STATUS  GetBootromVersion         ( char *ver );
STATUS  GetCDVersion              ( char *ver );
STATUS  GetCurrentDateClock       ( char *dc );
STATUS  GetModuleId               ( int mid,char *tid );
STATUS  GetSearchResult           ( int ndx,char *res,char *path );
STATUS  GetSourceDrive            ( char *path );
STATUS  InstallHDDTestFiles       ( void );
int     IsFpInLoader              ( void );
int     IsPartitionCaseSensitive  ( void );
int     IsPartitionUnderRepair    ( void );
void    loadFile                  ( void );
STATUS  LockCDEject               ( int on );
STATUS  ReadFileCRC               ( char *fn,char *crc );
void    RebootSystem              ( void );
int     SearchAndTargetFileExclu  ( char *fn,char *tn,char *par[],int npar,char *root,char *dir );
STATUS  SetBootLoaderFlag         ( int stayInBootLoader );
STATUS  SetMasterFlashingOn       ( void );
STATUS  SetPartitionRepairState   ( int repair );
STATUS  SetPower                  ( int on );
STATUS  SetRedLedOn               ( int on );
STATUS  SetUPGInProgressInCDD     ( int on );
STATUS  SetUpgradeLogging         ( int on );
STATUS  StopCOMModule             ( int mid );
STATUS  StopHDDActivity           ( void );
STATUS  UpdateFSImage             ( void );
STATUS  UPGCopy                   ( char *src,char *dst,int cut );
STATUS  UPGDelete                 ( char *fn );
void*   UPGFindSymbol             ( char *sym );
STATUS  UPGLogMsg                 ( char *fmt,... );

/* Functions and data types from MMI module
 */
#define NO                            0
#define YES                           1

STATUS  ClearScreen                   ( void );
STATUS  ShowNavigationBargraph        ( void );
STATUS  StepBargraph                  ( char *txt, int per );
STATUS  ShowNavigationQuestionScreen  ( char *txt, int *answ );

// Drive letters
#define DRIVE_USB       "/bd0"
#define DRIVE_HDD       "/C"
#define DRIVE_CD        "/D"
#define DRIVE_TFFS      "/F"
#define DRIVE_NAV       "/H"
#define DRIVE_USER      "/I"
#define DRIVE_JBX       "/J"


/* extra C standard function, pull out through modified Builtins.out
 */
void *pf_fread;
void *pf_fwrite;
void *pf_fseek;
void *pf_sprintf;
void *pf_memset;
void *pf_strchr;

STATUS InitFunctionPtr ( void )
{
  int   l_iAnsw;

  pf_fread    =UPGFindSymbol( "fread" );
  pf_fwrite   =UPGFindSymbol( "fwrite" );
  pf_fseek    =UPGFindSymbol( "fseek" );
  pf_sprintf  =UPGFindSymbol( "sprintf" );
  pf_memset   =UPGFindSymbol( "memset" );
  pf_strchr   =UPGFindSymbol( "strchr" );

  if( pf_fread  !=NULL &&
      pf_fwrite !=NULL &&
      pf_fseek  !=NULL &&
      pf_sprintf!=NULL &&
      pf_memset !=NULL &&
      pf_strchr !=NULL )    return OK;

  ShowNavigationQuestionScreen( "InitFunctionPtr() ERREUR!", &l_iAnsw );
  return ERROR;
}

/* these functions work only on modified Builtins.out crc=19bb6041
 */
#define FREAD( ptr,size,n,fp )      ExecuteFlasherOut( pf_fread,ptr,size,n,fp )
#define FWRITE( ptr,size,n,fp )     ExecuteFlasherOut( pf_fwrite,ptr,size,n,fp )
#define FSEEK( fp,offset,from )     ExecuteFlasherOut( pf_fseek,fp,offset,from )
#define MEMSET( ptr,value,len )     ExecuteFlasherOut( pf_memset,ptr,value,len )
#define STRCHR( str,chr )    (char*)ExecuteFlasherOut( pf_strchr,str,chr )
#define EFO                         ExecuteFlasherOut

/* Other builtins Functions and data type
 */
int     UPGSearchFile       ( char *fn, char *root, char *param, char *tabledir );
STATUS  UPGGetSearchResult  ( int ndx,char *res );
STATUS  GetFileSize         ( char *fn, int *size);


/* Functions and data types for file backup managment
 */
STATUS IsBackupPresent ( char *p_sFile )
{
  FILE *l_f;
  char  l_sBak[256];
  strcpy( l_sBak,p_sFile );
  strcat( l_sBak,".bak" );
  l_f=fopen( l_sBak,"rb" );
  if( l_f==NULL )
    return FALSE;
  fclose( l_f );
  return TRUE;
}

STATUS CreateBackup ( char *p_sFile )
{
  char  l_sBak[256];
  char  l_sInf[256];
  strcpy( l_sBak,p_sFile );
  strcat( l_sBak,".bak" );
  UPGCopy( p_sFile,l_sBak,0 );
  strcpy( l_sInf,p_sFile );
  strcat( l_sInf,".inf" );
  strcpy( l_sBak,l_sInf );
  strcat( l_sBak,".bak" );
  UPGCopy( l_sInf,l_sBak,0 );
  return OK;
}

STATUS RestoreBackup ( char *p_sFile )
{
  char  l_sBak[256];
  char  l_sInf[256];
  strcpy( l_sBak,p_sFile );
  strcat( l_sBak,".bak" );
  UPGCopy( l_sBak,p_sFile,0 );
  strcpy( l_sInf,p_sFile );
  strcat( l_sInf,".inf" );
  strcpy( l_sBak,l_sInf );
  strcat( l_sBak,".bak" );
  UPGCopy( l_sBak,l_sInf,0 );
  return OK;
}

/* Functions and data types for .INF file managment
 */
void    PatchCRC ( char *p_crc )
{
  if( p_crc[0]==' ' )   p_crc[0]='0';
  if( p_crc[1]==' ' )   p_crc[1]='0';
  if( p_crc[2]==' ' )   p_crc[2]='0';
  if( p_crc[3]==' ' )   p_crc[3]='0';
}

STATUS  UpdateFileInf ( char *p_sFile )
{
  FILE *l_f;
  char  l_crc[9];
  char  l_sInf[256];

  l_crc[0]=l_crc[1]=l_crc[2]=l_crc[3]=0;
  if( ComputeCRCFile( p_sFile,l_crc+4 )!=OK )
  	return ERROR;
  PatchCRC( l_crc+4 );
  l_crc[8]='\n';
  strcpy( l_sInf,p_sFile );
  strcat( l_sInf,".inf" );
  l_f=fopen( l_sInf,"r+b" );
  if( l_f==NULL )
  {
    l_f=fopen( l_sInf,"wb" );
    if( l_f==NULL )
      return ERROR;
  }
  FWRITE( l_crc,9,1,l_f );
  fclose( l_f );
  ComputeCRCFile( l_sInf,l_crc );
  PatchCRC( l_crc );
  l_f=fopen( l_sInf,"r+b" );
  if( l_f==NULL )
    return ERROR;
  FWRITE( l_crc,4,1,l_f );
  fclose( l_f );
  return OK;
}

/* RT4SET Local functions and data types
 */
STATUS ReadFileInt ( char *p_sFile,int p_iAddr,int p_iSize,int *p_iVal )
{
  BYTE  l_bVal[4];
  FILE *l_f;

  if( p_iSize!=1 && p_iSize!=2 && p_iSize!=4 )
    return ERROR;
  l_f=fopen( p_sFile,"rb" );
  if( l_f==NULL )
    return ERROR;
  FSEEK( l_f,p_iAddr,0 );
  FREAD( l_bVal,p_iSize,1,l_f );
  fclose( l_f );
  switch( p_iSize )
  {
  case 1:
    *p_iVal=*(BYTE*)l_bVal;
    break;
  case 2:
    *p_iVal=*(WORD*)l_bVal;
    break;
  case 4:
    *p_iVal=*(DWORD*)l_bVal;
    break;
  }
  return OK;
}

STATUS WriteFileInt ( char *p_sFile,int p_iAddr,int p_iSize,int p_iVal )
{
  BYTE  l_bVal[4];
  FILE *l_f;

  switch( p_iSize )
  {
  case 1:
    *(BYTE*)l_bVal=(BYTE)p_iVal;
    break;
  case 2:
    *(WORD*)l_bVal=(WORD)p_iVal;
    break;
  case 4:
    *(DWORD*)l_bVal=(DWORD)p_iVal;
    break;
  default:
    return ERROR;
  }
  l_f=fopen( p_sFile,"r+b" );
  if( l_f==NULL )
    return ERROR;
  FSEEK( l_f,p_iAddr,0 );
  FWRITE( l_bVal,p_iSize,1,l_f );
  fclose( l_f );
  return OK;
}

int   ModifyFileInt ( char *p_sName,int p_iHi,int p_iLo,int p_iAddr,int p_iSize,char *p_sFile )
{
  char  l_sText[256];
  int   l_iVal;
  int   l_iNew;
  int   l_iAnsw=NO;

  if( ReadFileInt( p_sFile,p_iAddr,p_iSize,&l_iVal )!=OK )
    return NO;
  l_iNew=l_iVal>p_iLo ? p_iLo : p_iHi;
  EFO( pf_sprintf,l_sText,"%s=%d. mettre a %d?",p_sName,l_iVal,l_iNew );
  ShowNavigationQuestionScreen( l_sText, &l_iAnsw );
  if( l_iAnsw==YES )
    WriteFileInt( p_sFile,p_iAddr,p_iSize,l_iNew );
  return l_iAnsw;
}

int   UserComVersion ( char *p_sFile )
{
  int l_iSize;
  if( GetFileSize( p_sFile,&l_iSize )!=OK )
    return ERROR;
  return l_iSize;
}

#define RT4_702_USERCOM         38708
#define RT4_711_USERCOM         29936
#define RT5_800_USERCOM         52888
#define RT5_810_USERCOM         55812

int   RT_general ( char *p_sUserCom,int p_iBase )
{
   return ModifyFileInt( "Coupure Video"     ,225,5,p_iBase+  0+0,1,p_sUserCom ) ;
}

int   RT_audio ( char *p_sUserCom,int p_iBase )
{
   return ModifyFileInt( "Presence Ampli"     ,1,0,p_iBase+  0+0,1,p_sUserCom ) ;
}

int   RT_menu ( char *p_sUserCom,int p_iBase )
{
   return ModifyFileInt( "Activer la prise AUX"      ,1,0,p_iBase+244+3,1,p_sUserCom ) ;
}

int   RT_trip ( char *p_sUserCom,int p_iBase )
{
   return ModifyFileInt( "D295"              ,1,0,p_iBase+ 36+3,1,p_sUserCom ) |
          ModifyFileInt( "D296"              ,1,0,p_iBase+ 40+3,1,p_sUserCom ) |
          ModifyFileInt( "Page ODB"          ,1,0,p_iBase+ 44+3,1,p_sUserCom ) |
          ModifyFileInt( "Page TRIP "         ,1,0,p_iBase+ 48+3,1,p_sUserCom ) |
          ModifyFileInt( "Menu Diagnostic"   ,1,0,p_iBase+ 52+3,1,p_sUserCom ) |
          ModifyFileInt( "Menu liste Service" ,1,0,p_iBase+ 56+3,1,p_sUserCom ) ;
}

int   RT_van ( char *p_sUserCom,int p_iBase )
{
   return ModifyFileInt( "Chargeur CD"        ,1,0,p_iBase+ 0+3,1,p_sUserCom ) |
          ModifyFileInt( "CDT"               ,1,0,p_iBase+ 4+3,1,p_sUserCom ) |
          ModifyFileInt( "B323"              ,1,0,p_iBase+ 8+0,1,p_sUserCom ) |
          ModifyFileInt( "B324"              ,1,0,p_iBase+ 9+0,1,p_sUserCom ) |
          ModifyFileInt( "B325"              ,1,0,p_iBase+10+0,1,p_sUserCom ) |
          ModifyFileInt( "B326"              ,1,0,p_iBase+11+0,1,p_sUserCom ) |
          ModifyFileInt( "B327"              ,1,0,p_iBase+12+0,1,p_sUserCom ) |
          ModifyFileInt( "B328"              ,1,0,p_iBase+13+0,1,p_sUserCom ) |
          ModifyFileInt( "DSG"               ,1,0,p_iBase+16+3,1,p_sUserCom ) |
          ModifyFileInt( "D330"              ,1,0,p_iBase+20+3,1,p_sUserCom ) |
          ModifyFileInt( "VTH"               ,1,0,p_iBase+24+3,1,p_sUserCom ) |
          ModifyFileInt( "D332"              ,1,0,p_iBase+28+3,1,p_sUserCom ) |
          ModifyFileInt( "Reset Tire U.P."   ,1,0,p_iBase+32+3,1,p_sUserCom ) |
          ModifyFileInt( "D334"              ,1,0,p_iBase+36+3,1,p_sUserCom ) |
          ModifyFileInt( "D335"              ,1,0,p_iBase+40+3,1,p_sUserCom ) |
          ModifyFileInt( "D336"              ,1,0,p_iBase+44+3,1,p_sUserCom ) |
          ModifyFileInt( "Radar arriere"  ,1,0,p_iBase+48+3,1,p_sUserCom ) |
          ModifyFileInt( "Radar avant" ,1,0,p_iBase+52+3,1,p_sUserCom ) |
          ModifyFileInt( "D339"              ,1,0,p_iBase+56+3,1,p_sUserCom ) |
          ModifyFileInt( "Hydr.susp.frame"   ,1,0,p_iBase+60+0,1,p_sUserCom ) |
          ModifyFileInt( "configuration EMF"        ,1,0,p_iBase+64+3,1,p_sUserCom ) |
          ModifyFileInt( "Desactiver Commande Vocale" ,1,0,p_iBase+68+3,1,p_sUserCom ) ;
}

int   RT_video ( char *p_sUserCom,int p_iBase )
{
   return ModifyFileInt( "D353"              ,1,0,p_iBase+ 0+3,1,p_sUserCom ) |
          ModifyFileInt( "D354"              ,1,0,p_iBase+ 4+3,1,p_sUserCom ) |
          ModifyFileInt( "D355"              ,1,0,p_iBase+ 8+3,1,p_sUserCom ) |
          ModifyFileInt( "Entre Video 1"        ,1,0,p_iBase+12+3,1,p_sUserCom ) |
          ModifyFileInt( "D357"              ,1,0,p_iBase+16+3,1,p_sUserCom ) |
          ModifyFileInt( "D358"              ,1,0,p_iBase+20+3,1,p_sUserCom ) ;
}

int   RT_AirC ( char *p_sUserCom,int p_iBase )
{
   return ModifyFileInt( "Desactiver D/G A/C"  ,1,0,p_iBase+ 0+3,1,p_sUserCom ) |
          ModifyFileInt( "A/C menu"          ,1,0,p_iBase+ 4+3,1,p_sUserCom ) |
          ModifyFileInt( "D387"              ,1,0,p_iBase+ 8+3,1,p_sUserCom ) |
          ModifyFileInt( "D388"              ,1,0,p_iBase+12+3,1,p_sUserCom ) ;
}

int   RT_Vconf ( char *p_sUserCom,int p_iBase )
{
   return ModifyFileInt( "Overtake help"     ,3,0,p_iBase+ 0+3,1,p_sUserCom ) |
          ModifyFileInt( "Near obstacle det" ,3,0,p_iBase+ 4+3,1,p_sUserCom ) |
          ModifyFileInt( "Driver wellcome"   ,1,0,p_iBase+ 8+3,1,p_sUserCom ) |
          ModifyFileInt( "Boot perm locking" ,1,0,p_iBase+12+3,1,p_sUserCom ) |
          ModifyFileInt( "Remote doors lock" ,1,0,p_iBase+16+3,1,p_sUserCom ) |
          ModifyFileInt( "Eclairage adaptatif"   ,1,0,p_iBase+20+3,1,p_sUserCom ) |
          ModifyFileInt( "Auto headlight"    ,1,0,p_iBase+24+3,1,p_sUserCom ) |
          ModifyFileInt( "Frein automatique"   ,1,0,p_iBase+28+3,1,p_sUserCom ) |
          ModifyFileInt( "Conf.Light menu"   ,1,0,p_iBase+32+3,1,p_sUserCom ) |
          ModifyFileInt( "Lumire ambiante"     ,1,0,p_iBase+36+3,1,p_sUserCom ) |
          ModifyFileInt( "Rear wiper"        ,1,0,p_iBase+40+3,1,p_sUserCom ) |
          ModifyFileInt( "Securoscope"       ,1,0,p_iBase+44+3,1,p_sUserCom ) |
          ModifyFileInt( "Doors selectivity" ,1,0,p_iBase+48+3,1,p_sUserCom ) |
          ModifyFileInt( "Feux diurne" ,1,0,p_iBase+52+3,1,p_sUserCom ) |
          ModifyFileInt( "COE locking mode"  ,1,0,p_iBase+56+3,1,p_sUserCom ) |
          ModifyFileInt( "Ouverture partielles des vitres",1,0,p_iBase+60+3,1,p_sUserCom ) |
          ModifyFileInt( "D417"              ,1,0,p_iBase+64+3,1,p_sUserCom ) |
          ModifyFileInt( "D418"              ,1,0,p_iBase+68+3,1,p_sUserCom ) |
          ModifyFileInt( "Assistance  la conduite",1,0,p_iBase+72+3,1,p_sUserCom ) |
          ModifyFileInt( "D420"              ,1,0,p_iBase+76+3,1,p_sUserCom ) |
          ModifyFileInt( "D421"              ,1,0,p_iBase+80+3,1,p_sUserCom ) |
          ModifyFileInt( "D422"              ,1,0,p_iBase+84+3,1,p_sUserCom ) |
          ModifyFileInt( "D423"              ,1,0,p_iBase+88+3,1,p_sUserCom ) |
          ModifyFileInt( "D424"              ,1,0,p_iBase+92+3,1,p_sUserCom ) ;
}

int   RT_display ( char *p_sUserCom,int p_iBase )
{
   return  ModifyFileInt( "Temperature exterieure"    ,1,0,p_iBase+ 0+3,1,p_sUserCom ) |
           ModifyFileInt( "Configuration"             ,1,0,p_iBase+ 4+3,1,p_sUserCom ) ;
}

int   main ( int argc,char *argv[] )
{
  int   l_iS032General;
  int   l_iS080Audio;
  int   l_iS176Menu;
  int   l_iS288Trip;
  int   l_iS320VAN;
  int   l_iS352Video;
  int   l_iS384AirC;
  int   l_iS400Vconf;
  int   l_iS432Display;
  int   l_iMdfy=NO;
  int   l_iAnsw=NO;
  char  l_sUserCom[256];
  char  l_sUserComTmp[256];


  if( InitFunctionPtr()==OK )
  {
    strcpy( l_sUserCom,DRIVE_USER "/USER_DATA/User_profile/User_com.dat" );

    if( IsBackupPresent( l_sUserCom )==TRUE )
    {
      ShowNavigationQuestionScreen( "Restaurer user_com.dat?",&l_iAnsw );
      if( l_iAnsw==YES )
        RestoreBackup( l_sUserCom );
    }
    if( l_iAnsw==NO )
    {
      ShowNavigationQuestionScreen( "Sauvegarder user_com.dat?",&l_iAnsw );
      if( l_iAnsw==YES )
        CreateBackup( l_sUserCom );
    }

    strcpy( l_sUserComTmp,l_sUserCom );
    strcat( l_sUserComTmp,".tmp" );
    UPGCopy( l_sUserCom,l_sUserComTmp,0 );

    switch( UserComVersion( l_sUserComTmp ) )
    {
    case RT4_702_USERCOM:
      l_iS032General=5788+    0;
      l_iS080Audio  =5788+  224;
      l_iS176Menu   =5788+  392;
      l_iS288Trip   =5788+22704;
      l_iS320VAN    =5788+22772;
      l_iS352Video  =5788+22832;
      l_iS384AirC   =5788+22912;
      l_iS400Vconf  =5788+22960;
      l_iS432Display=5788+23056;
      break;
    case RT4_711_USERCOM:
      l_iS032General=5836+    0;
      l_iS080Audio  =5836+  228;
      l_iS176Menu   =5836+  612;
      l_iS288Trip   =5836+23240;
      l_iS320VAN    =5836+23308;
      l_iS352Video  =5836+23380;
      l_iS384AirC   =5836+23460;
      l_iS400Vconf  =5836+23508;
      l_iS432Display=5836+23604;
      break;
    case RT5_800_USERCOM:
      l_iS032General=6636+    0;
      l_iS080Audio  =6636+  232;
      l_iS176Menu   =6636+  620;
      l_iS288Trip   =6636+40380;
      l_iS320VAN    =6636+40456;
      l_iS352Video  =6636+40528;
      l_iS384AirC   =6636+40608;
      l_iS400Vconf  =6636+40656;
      l_iS432Display=6636+40752;
      break;
    case RT5_810_USERCOM:
      l_iS032General=7164+    0;
      l_iS080Audio  =7164+  236;
      l_iS176Menu   =7164+  684;
      l_iS288Trip   =7164+40444;
      l_iS320VAN    =7164+40520;
      l_iS352Video  =7164+40592;
      l_iS384AirC   =7164+40672;
      l_iS400Vconf  =7164+40720;
      l_iS432Display=7164+40816;
      break;
    default:
      ShowNavigationQuestionScreen( "Verison de USER_COM.DAT inconnu!",&l_iAnsw );
      ClearScreen();
      return OK;
    }

    do
    {
      ShowNavigationQuestionScreen( "Voir/modifier parametre GENERAL ?",&l_iAnsw );
      if( l_iAnsw==YES )
        l_iMdfy |= RT_general( l_sUserComTmp,l_iS032General );

      ShowNavigationQuestionScreen( "Voir/modifier parametre AUDIO ?",&l_iAnsw );
      if( l_iAnsw==YES )
        l_iMdfy |= RT_audio( l_sUserComTmp,l_iS080Audio );

      ShowNavigationQuestionScreen( "Voir/modifier parametre MENU ?",&l_iAnsw );
      if( l_iAnsw==YES )
        l_iMdfy |= RT_menu( l_sUserComTmp,l_iS176Menu );

      ShowNavigationQuestionScreen( "Voir/modifier parametre TRIP ?",&l_iAnsw );
      if( l_iAnsw==YES )
        l_iMdfy |= RT_trip( l_sUserComTmp,l_iS288Trip );

      ShowNavigationQuestionScreen( "Voir/modifier parametre VAN?",&l_iAnsw );
      if( l_iAnsw==YES )
        l_iMdfy |= RT_van( l_sUserComTmp,l_iS320VAN );

      ShowNavigationQuestionScreen( "Voir/modifier parametre VIDEO ?",&l_iAnsw );
      if( l_iAnsw==YES )
        l_iMdfy |= RT_video( l_sUserComTmp,l_iS352Video );

      ShowNavigationQuestionScreen( "Voir/modifier parametre A/C ?",&l_iAnsw );
      if( l_iAnsw==YES )
        l_iMdfy |= RT_AirC( l_sUserComTmp,l_iS384AirC );

      ShowNavigationQuestionScreen( "Voir/modifier parametre Configuration Vehicule?",&l_iAnsw );
      if( l_iAnsw==YES )
        l_iMdfy |= RT_Vconf( l_sUserComTmp,l_iS400Vconf );

      ShowNavigationQuestionScreen( "Voir/modifier parametre Affichage?",&l_iAnsw );
      if( l_iAnsw==YES )
        l_iMdfy |= RT_display( l_sUserComTmp,l_iS432Display );

      ShowNavigationQuestionScreen( "Voir/modifier de nouveau un parametre ?",&l_iAnsw );
    }
    while( l_iAnsw==YES );

    if( l_iMdfy==NO )
      ShowNavigationQuestionScreen( "Aucun changement",&l_iAnsw );
    else
    {
      if( UpdateFileInf( l_sUserComTmp )!=OK )
        ShowNavigationQuestionScreen( "Erreur lors de la creation du fichier .INF.",&l_iAnsw );
      else
      {
        UPGCopy( l_sUserComTmp,l_sUserCom,1 );
        strcat( l_sUserCom,".inf" );
        strcat( l_sUserComTmp,".inf" );
        UPGCopy( l_sUserComTmp,l_sUserCom,1 );
        ShowNavigationQuestionScreen( "RTxSET termine! Redemarrer ?",&l_iAnsw );
        if( l_iAnsw==YES )
          RebootSystem();
      }
    }
  }
  ClearScreen();
  return OK;
}

