/*
 * INSTALL.CMD by mira308sw
 * French Translation by Pierre
 *
 * Copy *.INC files to RTx HDD /I/INC
 * Copy *.CMD files to RTx HDD /I/CMD
 *
 * v01.00:  first release
 */

#define DRIVE_USER          "/I"
#define DEF_INC_DIR         "/INC"
#define DEF_CMD_DIR         "/CMD"
#define DEF_VERSION_FILE    "/version.inc"
#define FILE                void
#define NULL                (void*)0
#define OK                  0
#define ERROR               -1
#define SKIP                1

#define TRUE                1
#define FALSE               0
#define NO                  0
#define YES                 1

char*   strcpy              ( char *dst, char *src );
char*   strcat              ( char *dst, char *src );
int     strcmp              ( char *s1,char *s2 );
char*   strrchr             ( char *s,int c );

FILE*   fopen               ( char *fn,char *mode );
int     fclose              ( FILE *f );
char*   fgets               ( char *s,int max,FILE *f );
int     xdelete                 ( char *src );

int     UPGSearchFile           ( char* Filename, char *RootDir, char *Param, char *TableDir );
int     UPGGetSearchResult      ( int index , char *SearchResult );
int     UPGCopy                 ( char *src,char* dts,int cut );
int     ShowNavigationBargraph  ( void );
int     StepBargraph            ( char *txt, int per );
int     ShowNavigationQuestionScreen  ( char *txt, int *answ );


int   NewVersion ( char *p_sVer )
{
  char  l_sIver[80];
  char  l_sNver[80];
  FILE *l_f;

  l_f=fopen( p_sVer,"rb" );
  if( l_f==NULL )
    return ERROR;
  fgets( l_sNver,sizeof( l_sNver ),l_f );
  fclose( l_f );
  l_f=fopen( DRIVE_USER DEF_INC_DIR DEF_VERSION_FILE,"rb" );
  if( l_f==NULL )
    return TRUE;
  fgets( l_sIver,sizeof( l_sIver ),l_f );
  fclose( l_f );
  return strcmp( l_sNver,l_sIver )!=0;
}

int   main ( int argc,char *argv[] )
{
  int   l_nFile;
  int   l_i;
  int   l_iAnsw;
  char  l_sSrc[256];
  char  l_sDst[256];
  char *l_p;

  strcpy( l_sSrc,argv[1] );
  strcat( l_sSrc,DEF_INC_DIR );
  strcat( l_sSrc,DEF_VERSION_FILE );

  switch( NewVersion( l_sSrc ) )
  {
  case FALSE:
    return OK;
  case ERROR:
    return SKIP;
  }

  ShowNavigationQuestionScreen( "Installer sur le disque dur ?",&l_iAnsw );
  if( l_iAnsw==NO )
    return SKIP;

  ShowNavigationBargraph();
  StepBargraph( "Copie fichier .inc",0 );
  strcpy( l_sSrc,argv[1] );
  strcat( l_sSrc,DEF_INC_DIR );
  l_nFile=UPGSearchFile( "*.inc",l_sSrc,NULL,NULL );
  xdelete( DRIVE_USER DEF_INC_DIR );
  for( l_i=0 ; l_i<l_nFile ; l_i++ )
  {
    if( UPGGetSearchResult( l_i,l_sSrc )==OK )
    {
      l_p=strrchr( l_sSrc,'/' );
      StepBargraph( l_p,100*(1+l_i)/l_nFile );
      strcpy( l_sDst,DRIVE_USER DEF_INC_DIR );
      strcat( l_sDst,l_p );
      UPGCopy( l_sSrc,l_sDst,0 );
    }
  }
  StepBargraph( "Copie fichier .cmd",0 );
  strcpy( l_sSrc,argv[1] );
  strcat( l_sSrc,DEF_CMD_DIR );
  l_nFile=UPGSearchFile( "*.CMD",l_sSrc,NULL,NULL );
  xdelete( DRIVE_USER DEF_CMD_DIR );
  for( l_i=0 ; l_i<l_nFile ; l_i++ )
  {
    if( UPGGetSearchResult( l_i,l_sSrc )==OK )
    {
      l_p=strrchr( l_sSrc,'/' );
      StepBargraph( l_p,100*(1+l_i)/l_nFile );
      strcpy( l_sDst,DRIVE_USER DEF_CMD_DIR );
      strcat( l_sDst,l_p );
      UPGCopy( l_sSrc,l_sDst,0 );
    }
  }
  StepBargraph( "Installation terminee!",100 );
  return OK;
}